SystemOrganization addCategory: #'GT-InspectorExtensions-XML'!

!ZnStringEntity methodsFor: '*GT-InspectorExtensions-XML' stamp: 'TudorGirba 7/7/2014 23:31'!
gtInspectorXmlIn: composite
	<gtInspectorPresentationOrder: 40>
	| xml |
	xml := [XMLDOMParser parse: self string]
		on: XMLWellFormednessException
		do: [ ^ self ].
	(xml gtInspectorTreeIn: composite)
		title: 'XML'! !

!XMLNodeWithElements methodsFor: '*GT-InspectorExtensions-XML' stamp: 'TudorGirba 7/16/2014 17:21'!
gtDisplayOn: stream
	stream nextPutAll: self name! !

!XMLNodeWithElements methodsFor: '*GT-InspectorExtensions-XML' stamp: 'TudorGirba 1/31/2014 07:22'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 40>
	composite text 
		title: 'Source';
		format: [ self prettyPrinted ]! !

!XMLNodeWithElements methodsFor: '*GT-InspectorExtensions-XML' stamp: 'TudorGirba 7/16/2014 17:21'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite tree 
		title: 'Tree';
		display: [ { self } ];
		children: #elements;
		format: #gtDisplayString;
		rootsExpanded! !

!XMLElement methodsFor: '*GT-InspectorExtensions-XML' stamp: 'AndreiChis 7/12/2014 16:48'!
formForImageEntity: imageEntity
  | imageType parserClassName parserClass parser |
  imageType := imageEntity contentType sub.
  parserClassName := imageType asUppercase, #ReadWriter.
  parserClass := Smalltalk globals at: parserClassName asSymbol.
  parser := parserClass on: imageEntity readStream.
    ^ parser nextImage! !

!XMLElement methodsFor: '*GT-InspectorExtensions-XML' stamp: 'AndreiChis 7/12/2014 20:14'!
gtInspectorImageIn: composite inContext: aGTInspector
	<gtInspectorPresentationOrder: 40>
	|client url|
	
	(aGTInspector panes size > 1) 
		ifFalse: [ ^ self ].	
	
	client := (aGTInspector panes reversed collect: [ :each | (each port: #entity) value ])
		detect: [ :each | 
			(each isKindOf: ZnClient)
				and: [each request notNil]]
		ifNone: [ ^ self ].
	url := client request absoluteUrl.
	
	^ composite morph 
		title: 'Image';
		display: [ 
			self formForImageEntity:
				(ZnClient new 
      				beOneShot;
      				get: url/ (self attributeNodes attributeValueAt: 'src');
      				entity)];
		when: [ self name = 'img' and: [(self attributeNodes attributeValueAt: 'src') notNil]]! !
